// Create a list out of all the objects on the stack and push the
// list. The other objects are left unchanged.
//
// Example:
// Input:
//   Level 3 4.
//   Level 2 "hello"
//   Level 1 3
//
// Output:
//   Level 4 4.
//   Level 3 "hello"
//   Level 2 3
//   Level 1 { 3 "hello" 4. }

#include <hpgcc49.h>
#include "hpobjects.h"

int main (int argc, char **argv)
{
    int i;			// counter
    SatAddr theList;		// The list object
    SatAddr *listObjs;		// The objects to store in the list
    int depth;			// original depth of the stack

    // The following line is only really necessary for HPGCC 1.1
    unsigned rpl_stack_bias = sat_stack_init();

    // Get the initial depth of the stack
    depth = STACKdepth();
    if (depth) {

	// Allocate a C array of SatAddrs to hold the stack items
	listObjs = calloc(depth, sizeof(SatAddr));

	// Copy the stack objects to the array.
	for (i = 1; i <= depth; ++i) {
	    listObjs[i-1] = STACKpick(i);
	}
	
	// Now create a list consisting of the objects.
	theList = LISTencodeN(depth, listObjs, 0);

	// Push the newly created list onto the stack
	STACKpush(theList);

	// Free the array
	free(listObjs);
    }

    // Clean up the stack (only necessary for HPGCC 1.1)
    sat_stack_exit(rpl_stack_bias);
    return 0;
}
