// Add together all the numbers in a list and push the sum onto
// the stack.  The original list is left unchanged.  This adds REALs
// and ZINTs. Anything else in the list is skipped.
//
// Example:
// Input:
//   Level 1 { 1. 2 3. "hello" }
//
// Output:
//   Level 2 { 1. 2 3. "hello" }
//   Level 1 6.

#include <hpgcc49.h>
#include "hpobjects.h"

int main (int argc, char **argv)
{
    SatAddr theList;		// The list object

    // The following line is only really necessary for HPGCC 1.1
    unsigned rpl_stack_bias = sat_stack_init();

    // Make sure there's at least one object on the stack
    if (STACKdepth()) {
	theList = STACKpick(1);	/* get the object at level 1 */
	if (isLIST(theList)) {	/* is it a list? */
	    SatAddr iter;	/* necessary to iterate the list */
	    SatAddr listOb;	/* an object in the list */
	    double sum = 0.0;	/* the running sum */
	    long long ll;	/* temporary */
	    double d;		/* temporary */
	    SatAddr result;	/* sum converted to a real */

	    // This is the code to walk through the objects in a list
	    // the variable "iter" is used to keep track of which item
	    // is next.
	    for (listOb = LISTfirstOb(theList, &iter);
		 listOb;
		 listOb = LISTnextOb(&iter)) {

		if (isREAL(listOb)) {
		    REALdecode(listOb, &d);
		    sum += d;
		} else if (isZINT(listOb)) {
		    ZINTdecodell(listOb, &ll);
		    sum += ll;
		} /* skip other types */
	    }

	    // Convert sum to a REAL in the calculator's temporary memory
	    result = REALencode(sum, 0);

	    // And push the real onto the stack
	    STACKpush(result);
	}
    }

    // Clean up the stack (only necessary for HPGCC 1.1)
    sat_stack_exit(rpl_stack_bias);
    return 0;
}
