// Program to tag the objects on the stack with the names of their prologs.
// Copyright David M. Hayden 2010

#include <hpgcc49.h>
#include "hpobjects.h"

int main (int argc, char **argv)
{
    int i;			// counter
    SatAddr stackObj;		// address of an object on the stack
    SatAddr taggedObj;		// address of corresponding tagged object
    SatAddr prolog;		// prolog of the object

    // The following line is only really necessary for HPGCC 1.1
    unsigned rpl_stack_bias = sat_stack_init();

    // Get the pointer the top of the stack
    SatAddr sp = sat_peek(SAT_DSKTOP, 5);
    int depth = STACKdepth();	// get depth of stack

    // For each object on the stack
    for (i=0; i < depth; ++i) {
	stackObj = sat_peek(sp+5*i, 5);	// get the address of the object
	prolog = obProlog(stackObj);    // and get its prolog

	// Now create a tagged object.  The first parameter
	// is a null-terminated string.  Here's we're passing
	// the result if prolog2Name(), which returns the name of a prolog.
	// The second parameter is the object to tag.  Here's it's the object
	// from the stack.  The third parameter says where to put the
	// tagged object.  "0" means to alloate new space for it in tempOb.
	taggedObj = TAGencode(prolog2Name(prolog), stackObj, 0);

	// Finally, replace the value on the stack with the tagged object.
	sat_poke(sp+5*i, taggedObj, 5);
    }

    // Clean up the stack (only necessary for HPGCC 1.1)
    sat_stack_exit(rpl_stack_bias);
    return 0;
}
