// Return the number of characters in the IDNT or LAM at SatAddr.
int LAMIDNTnumChars(SatAddr src);

// Convert from an HP IDNT or LAM pointed at by "src" into a null-terminated
// string located in the buffer pointed to by dst.  Dst must have
// enough space for the string and the null terminated buffer.
char * LAMIDNTtoStr(SatAddr src, char *dst);

// Convert from a NULL-terminated string to an HP IDNT or HP LAM.
// "dst" must have enough room to hold the identifier. This writes
// all data for the object, including the prolog and size fields
SatAddr LAMIDNTstr2(const char *src, SatAddr dst, int prolog);

/* Allocate space for an IDNT or LAM with numChars characters, and put
   an empty IDNT at the beginning of the space. Return the address of
   the IDNT. You can add data to the identifier with IDNTadd(), as
   long as the total number of characters added doesn't exceed
   numChars. */
SatAddr LAMIDNTmake(size_t size, int prolog);

// Return the size in nibbles of the IDNT object at src.  Returns -1
// if the object isn't a identifier
int LAMIDNTnibbles(SatAddr src);
