#include <hpgcc49.h>
#include "hpobjects.h"

// This file contains functions to convert native HP objects to/from
// ARM equivalents

/////////////////////////////////////////////////////////////////////
//
//                         BINT
//
/////////////////////////////////////////////////////////////////////
//++

bool isBINT(SatAddr src)
{
    int prolog = sat_peek_sat_addr(src);
    return (prolog == SAT_DOBINT);
}

bool
BINTdecode(SatAddr src, int *dst)
{
    if (!isBINT(src)) return false;
    *dst = sat_peek_sat_addr(src+5);
    return true;
}

// Copy the integer i to SatAddr dst, which is assumed to contain
// enough space for the BINT.
SatAddr BINTencode(int i, SatAddr dst)
{
    if (i<0 || i > 0xfffff) return 0;
    if (dst==0) {
	dst = makeBINT();
    }
    sat_poke(dst, SAT_DOBINT, 5);
    sat_poke(dst+5, i, 5);
    return dst;
}

SatAddr makeBINT()
{
    SatAddr result = sat_createtemp(10);
    sat_poke(result, SAT_DOBINT, 5);
    return result;
}

