#include <hpgcc49.h>
#include "hpobjects.h"

// This file contains functions to convert native HP objects to/from
// ARM equivalents


/////////////////////////////////////////////////////////////////////
//
//                         CHAR
//
/////////////////////////////////////////////////////////////////////
//++
bool isCHAR(SatAddr src)
{
    int prolog = sat_peek_sat_addr(src);
    return (prolog == SAT_DOCHAR);
}

// Convert a CHAR object to a char
bool
CHARdecode(SatAddr src, char *dst)
{
    if (!isCHAR(src)) return false;
    *dst = sat_peek(src+5,2);
    return true;
}

// Copy the char ch to SatAddr dst, which is assumed to contain
// enough space for the CHAR.
SatAddr CHARencode(unsigned char ch, SatAddr dst)
{
    if (dst == 0) {
	dst = makeCHAR();
    }
    sat_poke(dst, SAT_DOCHAR, 5);
    sat_poke(dst+5, ch, 2);
    return dst;
}

SatAddr makeCHAR()
{
    SatAddr result = sat_createtemp(7);
    sat_poke(result, SAT_DOCHAR, 5);
    return result;
}

