#include <hpgcc49.h>
#include "hpobjects.h"

/////////////////////////////////////////////////////////////////////
// FLASH PTR routines
//

//
// A flash pointer is:
// Prolog (5 nibbles)
// table A (3 nibbles)
// table B (4 nibbles)
/////////////////////////////////////////////////////////////////////


//++
bool isFLASHP(SatAddr src)
{
    return (obProlog(src) == SAT_DOFLASHP);
}

bool FLASHPdecode(SatAddr src, int *a, int *b)
{
    if (!isFLASHP(src)) return false;
    if (a) {
	*a = sat_peek(src+5, 3);
    }
    if (b) {
	*b = sat_peek(src+8,4);
    }
    return true;
}

SatAddr FLASHPencode(int a, int b, SatAddr dst)
{
    if (a<0 || a>0xfff) return 0;
    if (b<0 || b>0xffff) return 0;
    if (dst==0) {
	dst = sat_createtemp(12);
    }
    if (dst) {
	sat_poke(dst, SAT_DOFLASHP, 5);
	sat_poke(dst+5, a, 3);
	sat_poke(dst+8, b, 4);
    }
    return dst;
}

SatAddr makeFLASHP()
{
    return FLASHPencode(0,0,0);
}

