#include <hpgcc49.h>
#include "hpobjects.h"

/////////////////////////////////////////////////////////////////////
// MINIFONT.  
/////////////////////////////////////////////////////////////////////

//++
bool isMINIFONT(SatAddr src)
{
    int prolog = sat_peek_sat_addr(src);
    return (prolog == SAT_DOMINIFONT);
}

//Return a pointer to the 6-nibble minifont entry corresponding to
//char "idx"
SatAddr MINIFONTitem(SatAddr src, int idx)
{
    SatAddr result;

    if (!isMINIFONT(src)) return 0;
    if (idx<0 || idx >255) return 0;

    result = src + 10 + 2 + 6*idx;
    return result;
}

// Set/get the minifont ID number
int MINIFONTgetId(SatAddr src)
{
    if (!isMINIFONT(src)) return -1;
    return sat_peek(src+10, 2);
}

bool MINIFONTsetId(SatAddr src, int id)
{
    if (id<0 || id > 0xff) return false;
    sat_poke(src+10, id, 2);
    return true;
}

SatAddr makeMINIFONT()
{
    SatAddr result = sat_createtemp(1548);
    sat_poke(result, SAT_DOMINIFONT, 5);
    sat_poke(result+5, 1543, 5);
    return result;
}
