#include <hpgcc49.h>
#include "hpobjects.h"

/////////////////////////////////////////////////////////////////////
//
//                         REAL
//
/////////////////////////////////////////////////////////////////////

//++

bool isREAL(SatAddr src)
{
    int prolog = sat_peek_sat_addr(src);
    return (prolog == SAT_DOREAL);
}

// Convert an HP REAL object to a C double. Returns true of false.
bool REALdecode(SatAddr src, double *dst)
{
    if (!isREAL(src)) return false;
    *dst = sat_real2double(src+5);
    return true;
}


// Convert a C double (d) to an HP REAL object at Saturn address dst.
// returns true on success otherwise false.
// 
SatAddr REALencode(double d, SatAddr dst)
{
    if (dst == 0) {
	dst = makeREAL();
    }
    sat_poke(dst, SAT_DOREAL, 5);
    double2hp(d, dst+5);
    return dst;
}

// Create an uninitialized HP real object in temp space and returns
// its address.
SatAddr makeREAL()
{
    SatAddr result = sat_createtemp(21);
    sat_poke(result, SAT_DOREAL, 5);
    sat_memset(result+5, 0, 16);
    return result;
}
