#include <stdio.h>
#include <string.h>

char headers[10000];
char buffered[10000];

int doFile(const char *name)
{
    char line[300];
    char outFileName[100];
    FILE *outFile;
    FILE *infile = fopen(name, "r");

    printf("Splitting files in %s\n", name);
    if (infile == NULL) {
	printf("can't open %s\n", name);
	return 0;
    }

    // Read forward til you find a line beginning with /++
    // this signifies the headers in the file.
    headers[0] = 0;
    while (fgets(line, sizeof(line), infile)) {
	if (strncmp(line, "//++", 4) == 0) {
	    break;
	}
	strcat(headers, line);
    }
    while (!feof(infile)) {
	// Copy lines into the buffer until you get one with a single {
	// in the first column
	buffered[0] = 0;
	while (fgets(line, sizeof(line), infile)) {
	    strcat(buffered, line);
	    if (line[0] == '{') {
		// figure out the name of the output file.
		const char *cp = buffered + strlen(buffered);
		const char *cp2;
		// backup to "("
		while (cp >=buffered && *cp != '(') {
		    --cp;
		}
		// backup to whitespace
		for (cp2 = cp-1;
		     cp2 >= buffered && (isdigit(*cp2)||isalpha(*cp2));
		     --cp2)
		    ;
		if (cp2 <= buffered) {
		    break;
		}
		++cp2;
		memcpy(outFileName, cp2, cp-cp2);
		outFileName[cp-cp2]=0;
		strcat(outFileName, ".c");
		printf("  writing %s\n", outFileName);
		outFile = fopen(outFileName, "w");
		fprintf(outFile,
			"// DO NOT EDIT THIS FILE\n"
			"// This file was generated by splitFiles.exe\n"
			"// from %s. Edit that file and re-run splitFiles\n\n",
			name);
		fwrite(headers, 1, strlen(headers), outFile);
		fwrite(buffered, 1, strlen(buffered), outFile);
		break;
	    }
	}
	if (feof(infile)) {
	    printf("end of %s\n", name);
	    break;
	}
	// now write to outfile until you hit }
	while (fgets(line, sizeof(line), infile)) {
	    fputs(line, outFile);
	    if (line[0] == '}') {
		fclose(outFile);
		break;
	    }
	}
    }
}


int
main(int argc, char **argv)
{
    int i;
    for (i=1; i < argc; ++i) {
	doFile(argv[i]);
    }
    return 0;
}
