#include <hpgcc49.h>
#include "hpobjects.h"

//++

// XLIB routines
bool isXLIB(SatAddr src)
{
    int prolog = sat_peek_sat_addr(src);
    return (prolog == SAT_DOXLIB);
}

// Extract the library and command numbers from an XLIB object
bool XLIBdecode(SatAddr src, int *lib, int *cmd)
{
    if (!isXLIB(src)) return false;
    if (lib) {
	*lib = sat_peek(src+5, 3);
    }
    if (cmd) {
	*cmd = sat_peek(src+5+3, 3);
    }
    return true;
}


// Put the library and command numbers into the xlib.  This
// assumes that dst points to an xlib object.
SatAddr XLIBencode(int lib, int cmd, SatAddr dst)
{
    if (lib<0 || lib>0xfff) return 0;
    if (cmd<0 || cmd>0xfff) return 0;

    if (dst == 0) {
	dst = makeXLIB();
    }
    sat_poke(dst, SAT_DOXLIB, 5);
    sat_poke(dst+5, lib, 3);
    sat_poke(dst+5+3, cmd, 3);
    return dst;
}


// Create an empty XLIB. Contents are undefined.
SatAddr makeXLIB()
{
    SatAddr result = sat_createtemp(5+3+3);
    XLIBencode(0, 0, result);
    return result;
}


